////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Ultima Dark Runes - RPG game engine
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"
#include "tiles.h"
#include "map.h"
#include "data.h"

char VersionPtr[] = "Ultima DR";
int AppStackSize = 3000;

MESSAGE msg;
char x=51, y=34, d=25; // Char starting pos & char gfx

void mbox(char *s)
{
  LcdRasterOp(WHITE,160,33,NULL,0,0,NULL,0,127); // Clear bottom
  LcdDrawBox(DRAW_BLACK,0,127,159,159);          // Draw msg frame
  LcdPutStringXY(-1,129,s,-1,LCD_CENTERED|LCD_MULTILINE);
  RimGetMessage(&msg);                           // Wait for key
}

void tmsg(char a, char b, char *s)
{
  char z;
  for(z=0; z<tmax; z++)
    if(sign[z].x==a&&sign[z].y==b) s=sign[z].txt; // Msg at pos check
  mbox(s);
}

void UltMain(void)
{
  char a=0,b=0,buf[64];
  int h, v;
  char ST=15,DX=13,IN=12; // Strength, Dexterity, Intelligence
  char LV=1,KY=1,PO=1;    // Level, Keys, potions 
  int HP=16,HT=16,GD=10;  // Hit Points, HP total, Gold
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  srand(RimGetTicks());

  for (;;) // Start message loop
  {
    for(v=0;v<10;v++)
      for(h=0;h<10;h++)
        LcdRasterOp(COPY_SRC,16,16,&Tiles,m[v+y-4][h+x-4]%8*16,
                           m[v+y-4][h+x-4]/8*16,NULL,h*16,v*16); // Draw tile
    LcdRasterOp(COPY_SRC,16,16,&Tiles,d%8*16,d/8*16,NULL,64,64); // Draw char

    RimSprintf(buf,63,"x:%d y:%d  a:%d b:%d  m[b][a]:%d ",x,y,a,b,m[b][a]);
    LcdPutStringXY(0,152,buf,-1,0);

    RimGetMessage(&msg);
    switch (msg.Device)
    {
      case DEVICE_KEYPAD:
        switch (msg.Event)
        {
          case KEY_DOWN: case KEY_REPEAT:
          {
            switch (msg.SubMsg)
            {
              case KEY_ESCAPE: // ESC key exits
                mbox("Quit, Are you sure?\n[y]es  [n]o");
                if(msg.SubMsg=='y')
                {
                  RibbonShowRibbon();
                  RimTerminateThread();
                }
              case 'q': a=x;b=y-1;d=25;break; // NORTH
              case 'z': a=x;b=y+1;d=27;break; // SOUTH
              case 'a': a=x-1;b=y;d=24;break; // WEST
              case 's': a=x+1;b=y;d=26;break; // EAST
              case ' ': mbox("Stats:");break;
            }
          }
          if(m[b][a]<4) {x=a;y=b;} // Walkable space
          if(m[b][a]==11) m[b][a+1]=m[b][a+1]?0:10; // Open-close gate
          if(m[b][a]==8) tmsg(a,b,"Sign is illegible!");  // Sign
          if(m[b][a]==12) tmsg(a,b,"Script is unknown!"); // Book
          if(m[b][a]>23&&m[b][a]<28) tmsg(a,b,"Well met, Traveler!"); // Talk
          if(m[b][a]==4) {m[b][a]=0;GD+=(rand()&15);} // Gold
          if(m[b][a]==16&&KY) {m[b][a]=3;KY--;} // Keys
//        if(m[b][a]==9&&m[2*(b-y)][2*(a-x)]==0) m[b][a]=0; // Boulder
      } // End keypad
    }
  } // Message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr, &IconBMP, 0, 40, UltMain, AppStackSize);
}
